;;; Sierra Script 1.0 - (do not remove this comment)
(script# 203)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use StatusBar)
(use Interface)
(use Game)

(public
	chAlloc 0
)

(local
	currentPool
	maxPool
	[str 80]
)
(procedure (ResetLastViewedStats &tmp i)
	(= i 0)
	(while (< i 25)
		(= [lastViewedSkills i] [egoStats i])
		(++ i)
	)
)

(procedure (DisplayStatBar x y color)
	(Display &rest
		100 x y ;CI: NOTE: SCICompanion will not compile if a #define is immediately after a &rest modifier
		p_mode teJustLeft
		p_font 300
		p_color color
		p_back vWHITE
	)
)

(procedure (DisplayPointsPool)
	(DisplayStatBar
		40
		127
		statColour
		(Format @str 203 0 currentPool maxPool)
		p_width 52
	)
	;%d / %d
	(poolBar max: maxPool value: currentPool draw:)
	(SetUpEgo)
)

(instance nameEdit of DEdit
	(properties
		nsTop 6
		nsLeft 58
		nsBottom 19
		nsRight 310
		font 300
		max 40
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (pEvent claimed?) (return 0))
		(if (& state dSelected)
			(if (== direction (pEvent type?))
				(pEvent type: keyDown)
				(switch (pEvent message?)
					(dirS
						(pEvent message: DOWNARROW)
					)
					(dirN 
						(pEvent message: UPARROW)
					)
				)
			)
			(if
			(and (& state dSelected) (== keyDown (pEvent type?)))
				(switch (pEvent message?)
					(DOWNARROW
						(pEvent message: TAB)
					)
					(UPARROW 
						(pEvent message: SHIFTTAB)
					)
				)
			)
		)
		(return (super handleEvent: pEvent))
	)
)

(class BoxSelector of DItem
	(properties
		type $000a
		state dActive
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		key 0
		said 0
		value 0
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (pEvent claimed?) (return 0))
		(if (= temp0 (super handleEvent: pEvent))
			(return temp0)
		)
		(if (not (& state dSelected)) (return 0))
		(if (== direction (pEvent type?))
			(pEvent type: keyDown)
			(switch (pEvent message?)
				(dirS
					(pEvent message: DOWNARROW)
				)
				(dirN 
					(pEvent message: UPARROW)
				)
				(dirE
					(pEvent message: RIGHTARROW)
				)
				(dirW
					(pEvent message: LEFTARROW)
				)
				(else  
					(pEvent type: direction)
				)
			)
		)
		(switch (pEvent type?)
			(keyDown
				(pEvent claimed: TRUE)
				(switch (pEvent message?)
					(UPARROW 
						(pEvent message: SHIFTTAB)
					)
					(DOWNARROW
						(pEvent message: TAB)
					)
					(RIGHTARROW 
						(self incr: 5)
					)
					(LEFTARROW 
						(self dec: 5)
					)
					(KEY_EXECUTE ;numpad +
						(self incr: 1)
					)
					(KEY_SUBTRACT ;numpad -
						(self dec: 1)
					)
					(else  
						(pEvent claimed: FALSE)
					)
				)
			)
		)
		(return 0)
	)
	
	(method (draw)
		(DrawCel
			802
			1
			(if (& state dSelected) 1 else 2)
			nsLeft
			nsTop
			-1
		)
	)
	
	(method (incr amount)
		(if (not currentPool) (return))
		(if (< currentPool amount) (= amount currentPool))
		(if (== [egoStats value] 0)
			(if (< currentPool 15) (return))
			(= [egoStats value] 5)
			(= currentPool (- currentPool 15))
		else
			(= [egoStats value] (+ [egoStats value] amount))
			(= currentPool (- currentPool amount))
		)
		(self select: 0)
		(= [egoStats HEALTH] (GetMaxHealth))
		(= [egoStats STAMINA] (GetMaxStamina))
		(= [egoStats MANA] (GetMaxMana))
		(DisplayPointsPool)
		((ScriptID 204 0) update:)
		(self select: 1)
	)
	
	(method (dec amount &tmp temp0)
		(if
			(not
				(= temp0 (- [egoStats value] [lastViewedSkills value]))
			)
			;the skill is already at it's baseline (for this heroType), so nothing to decrease.
			(return)
		)
		;CI: NOTE: there is a bug, where if the stat is 6 or higher, 
		;you can remove 5 and skip the 15-point pool allocation
		(if (== [egoStats value] 5)
			(= [egoStats value] 0)
			(= currentPool (+ currentPool 15))
		else
			(if (< temp0 amount) (= amount temp0))
			(= [egoStats value] (- [egoStats value] amount))
			(= currentPool (+ currentPool amount))
		)
		(self select: 0)
		(= [egoStats HEALTH] (GetMaxHealth))
		(= [egoStats STAMINA] (GetMaxStamina))
		(= [egoStats MANA] (GetMaxMana))
		(DisplayPointsPool)
		((ScriptID 204 0) update:)
		(self select: 1)
	)
)

(instance strengthSel of BoxSelector
	(properties
		nsTop 33
		nsLeft 81
		nsBottom 46
		nsRight 191
	)
)

(instance intSel of BoxSelector
	(properties
		nsTop 45
		nsLeft 81
		nsBottom 58
		nsRight 191
		value 1
	)
)

(instance agilSel of BoxSelector
	(properties
		nsTop 57
		nsLeft 81
		nsBottom 70
		nsRight 191
		value 2
	)
)

(instance vitSel of BoxSelector
	(properties
		nsTop 69
		nsLeft 81
		nsBottom 82
		nsRight 191
		value 3
	)
)

(instance luckSel of BoxSelector
	(properties
		nsTop 81
		nsLeft 81
		nsBottom 94
		nsRight 191
		value 4
	)
)

(instance wpnSel of BoxSelector
	(properties
		nsTop 26
		nsLeft 205
		nsBottom 39
		nsRight 315
		value 5
	)
)

(instance parrySel of BoxSelector
	(properties
		nsTop 38
		nsLeft 205
		nsBottom 51
		nsRight 315
		value 6
	)
)

(instance dodgeSel of BoxSelector
	(properties
		nsTop 50
		nsLeft 205
		nsBottom 63
		nsRight 315
		value 7
	)
)

(instance stealthSel of BoxSelector
	(properties
		nsTop 62
		nsLeft 205
		nsBottom 75
		nsRight 315
		value 8
	)
)

(instance pickSel of BoxSelector
	(properties
		nsTop 74
		nsLeft 205
		nsBottom 87
		nsRight 315
		value 9
	)
)

(instance throwSel of BoxSelector
	(properties
		nsTop 86
		nsLeft 205
		nsBottom 99
		nsRight 315
		value 10
	)
)

(instance climbSel of BoxSelector
	(properties
		nsTop 98
		nsLeft 205
		nsBottom 111
		nsRight 315
		value 11
	)
)

(instance magicSel of BoxSelector
	(properties
		nsTop 110
		nsLeft 205
		nsBottom 123
		nsRight 315
		value 12
	)
)

(class CSDButton of DButton
	(properties
		type dButton
		state (| dActive dExit)
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		key 0
		said 0
		value 0
		text 0
		font 0
	)
	
	(method (handleEvent pEvent &tmp temp0)
		(if (pEvent claimed?) (return 0))
		(if (& state dSelected)
			(if (== direction (pEvent type?))
				(pEvent type: keyDown)
				(switch (pEvent message?)
					(dirS
						(pEvent message: DOWNARROW)
					)
					(dirN 
						(pEvent message: UPARROW)
					)
				)
			)
			(if
			(and (& state dSelected) (== keyDown (pEvent type?)))
				(switch (pEvent message?)
					(DOWNARROW
						(pEvent message: TAB)
					)
					(UPARROW 
						(pEvent message: SHIFTTAB)
					)
				)
			)
		)
		(return (super handleEvent: pEvent))
	)
)

(instance exitButton of CSDButton
	(properties
		nsTop 156
		nsLeft 210
		text { Start Game_}
	)
)

(instance canButton of CSDButton
	(properties
		nsTop 171
		nsLeft 226
		text { Cancel_}
	)
)

(instance statDial of Dialog
	(properties
		nsBottom 189
		nsRight 319
	)
)

(instance poolBar of StatusBar
	(properties
		x 95
		y 132
		titleCel 4
	)
)

(instance chAlloc of Room
	(properties
		picture 401
		style $0064
	)
	
	(method (init &tmp temp0 temp1 temp2)
		(asm
			pushi    2
			pushi    RES_SCRIPT
			pushi    204
			callk    Load,  4
			pushi    2
			pushi    RES_SCRIPT
			pushi    205
			callk    Load,  4
			pushi    2
			pushi    RES_VIEW
			pushi    vEgoCharSheet
			callk    Load,  4
			pushi    2
			pushi    RES_VIEW
			lsg      hpStatusView
			callk    Load,  4
			pushi    #init
			pushi    0
			super    Room,  4
			pushi    #stop
			pushi    0
			lag      cSound
			send     4
			pushi    0
			ldi      13
			sagi     egoStats
			pushi    10
			ldi      1
			sagi     invNum
			pushi    4
			ldi      2
			sagi     invNum
			pushi    #use
			pushi    1
			pushi    6
			pushi    323
			pushi    1
			pushi    9
			pushi    323
			pushi    1
			pushi    7
			pushi    323
			pushi    1
			pushi    23
			pushi    323
			pushi    1
			pushi    8
			pushi    323
			pushi    2
			pushi    3
			pushi    5
			lag      ego
			send     38
			ldi      0
			sag      userName
			ldi      50
			sal      currentPool
			pushi    0
			ldi      17
			sagi     egoStats
			pushi    0
			ldi      18
			sagi     egoStats
			pushi    0
			ldi      21
			sagi     egoStats
			pushi    0
			ldi      23
			sagi     egoStats
			pushi    0
			ldi      24
			sagi     egoStats
			lsg      heroType
			dup     
			ldi      0
			eq?     
			bnt      code_08f1
			pushi    25
			ldi      0
			sagi     egoStats
			pushi    10
			ldi      1
			sagi     egoStats
			pushi    15
			ldi      2
			sagi     egoStats
			pushi    15
			ldi      3
			sagi     egoStats
			pushi    10
			ldi      4
			sagi     egoStats
			pushi    20
			ldi      5
			sagi     egoStats
			pushi    15
			ldi      6
			sagi     egoStats
			pushi    10
			ldi      7
			sagi     egoStats
			pushi    0
			ldi      8
			sagi     egoStats
			pushi    0
			ldi      9
			sagi     egoStats
			pushi    10
			ldi      10
			sagi     egoStats
			pushi    0
			ldi      11
			sagi     egoStats
			pushi    0
			ldi      12
			sagi     egoStats
			pushi    #get
			pushi    1
			pushi    6
			pushi    237
			pushi    1
			pushi    9
			lag      ego
			send     12
			jmp      code_09bb
code_08f1:
			dup     
			ldi      1
			eq?     
			bnt      code_0954
			pushi    10
			ldi      0
			sagi     egoStats
			pushi    25
			ldi      1
			sagi     egoStats
			pushi    15
			ldi      2
			sagi     egoStats
			pushi    15
			ldi      3
			sagi     egoStats
			pushi    10
			ldi      4
			sagi     egoStats
			pushi    10
			ldi      5
			sagi     egoStats
			pushi    0
			ldi      6
			sagi     egoStats
			pushi    15
			ldi      7
			sagi     egoStats
			pushi    0
			ldi      8
			sagi     egoStats
			pushi    0
			ldi      9
			sagi     egoStats
			pushi    0
			ldi      10
			sagi     egoStats
			pushi    0
			ldi      11
			sagi     egoStats
			pushi    25
			ldi      12
			sagi     egoStats
			pushi    10
			ldi      21
			sagi     egoStats
			pushi    #get
			pushi    1
			pushi    7
			lag      ego
			send     6
			jmp      code_09bb
code_0954:
			dup     
			ldi      2
			eq?     
			bnt      code_09bb
			pushi    10
			ldi      0
			sagi     egoStats
			pushi    15
			ldi      1
			sagi     egoStats
			pushi    25
			ldi      2
			sagi     egoStats
			pushi    10
			ldi      3
			sagi     egoStats
			pushi    10
			ldi      4
			sagi     egoStats
			pushi    10
			ldi      5
			sagi     egoStats
			pushi    0
			ldi      6
			sagi     egoStats
			pushi    5
			ldi      7
			sagi     egoStats
			pushi    10
			ldi      8
			sagi     egoStats
			pushi    10
			ldi      9
			sagi     egoStats
			pushi    5
			ldi      10
			sagi     egoStats
			pushi    5
			ldi      11
			sagi     egoStats
			pushi    0
			ldi      12
			sagi     egoStats
			pushi    #get
			pushi    1
			pushi    7
			pushi    237
			pushi    1
			pushi    23
			lag      ego
			send     12
			ldi      10
			sag      lockPickBonus
code_09bb:
			toss    
			lal      currentPool
			sal      maxPool
			pushi    0
			callb    GetMaxHealth,  0
			push    
			ldi      HEALTH
			sagi     egoStats
			pushi    0
			callb    GetMaxStamina,  0
			push    
			ldi      STAMINA
			sagi     egoStats
			pushi    0
			callb    GetMaxMana,  0
			push    
			ldi      MANA
			sagi     egoStats
			pushi    #get
			pushi    1
			pushi    8
			pushi    237
			pushi    2
			pushi    3
			pushi    5
			lag      ego
			send     14
			pushi    0
			call     ResetLastViewedStats,  0
			pushi    #text
			pushi    1
			lea      @userName
			push    
			pushi    36
			pushi    1
			pushi    1
			lea      @userName
			push    
			callk    StrLen,  2
			push    
			lofsa    nameEdit
			send     12
			pushi    #setSize
			pushi    0
			lofsa    exitButton
			send     4
			pushi    #setSize
			pushi    0
			lofsa    canButton
			send     4
			pushi    #window
			pushi    1
			lsg      systemWindow
			pushi    97
			pushi    16
			lofsa    nameEdit
			push    
			lofsa    strengthSel
			push    
			lofsa    intSel
			push    
			lofsa    agilSel
			push    
			lofsa    vitSel
			push    
			lofsa    luckSel
			push    
			lofsa    wpnSel
			push    
			lofsa    parrySel
			push    
			lofsa    dodgeSel
			push    
			lofsa    stealthSel
			push    
			lofsa    pickSel
			push    
			lofsa    throwSel
			push    
			lofsa    climbSel
			push    
			lofsa    magicSel
			push    
			lofsa    exitButton
			push    
			lofsa    canButton
			push    
			pushi    152
			pushi    2
			pushi    0
			pushi    15
			lofsa    statDial
			send     50
			pushi    #useWindow
			pushi    1
			pushi    0
			pushi    412
			pushi    1
			pushi    0
			pushi    87
			pushi    0
			pushi    2
			pushi    204
			pushi    0
			callk    ScriptID,  4
			send     16
			pushi    11
			pushi    203
			pushi    1
			pushi    100
			pushi    62
			pushi    109
			pushi    101
			pushi    0
			pushi    105
			pushi    300
			pushi    102
			lsg      statColourNew
			callk    Display,  22
			pushi    #max
			pushi    1
			lsl      maxPool
			pushi    77
			pushi    1
			lsl      currentPool
			pushi    87
			pushi    0
			lofsa    poolBar
			send     16
			pushi    13
			pushi    203
			pushi    2
			pushi    100
			pushi    165
			pushi    127
			pushi    106
			pushi    150
			pushi    101
			pushi    0
			pushi    105
			pushi    300
			pushi    102
			lsg      statColourNew
			callk    Display,  26
			pushi    0
			call     DisplayPointsPool,  0
			pushi    0
			callb    SetUpEgo,  0
			pushi    #setCursor
			pushi    2
			lsg      normalCursor
			pushi    1
			lag      theGame
			send     8
			ldi      1
			sat      temp1
			ldi      300
			sat      temp2
code_0af9:
			lat      temp1
			bnt      code_0b7b
			pushi    #doit
			pushi    0
			lofsa    statDial
			send     4
			sat      temp0
			not     
			bt       code_0b15
			lst      temp0
			lofsa    canButton
			eq?     
			bnt      code_0b43
code_0b15:
			pushi    8
			pushi    203
			pushi    3
			pushi    81
			lofsa    {Yes}
			push    
			pushi    1
			pushi    81
			lofsa    {No}
			push    
			pushi    2
			calle    Print,  16
			sat      temp0
			push    
			ldi      1
			eq?     
			bnt      code_0af9
			ldi      0
			sat      temp1
			ldi      202
			sat      temp2
			jmp      code_0af9
code_0b43:
			lsl      currentPool
			ldi      0
			gt?     
			bnt      code_0b74
			pushi    8
			pushi    203
			pushi    4
			pushi    81
			lofsa    {Start the Game}
			push    
			pushi    1
			pushi    81
			lofsa    {Use More Points}
			push    
			pushi    2
			calle    Print,  16
			sat      temp0
			push    
			ldi      1
			eq?     
			bnt      code_0af9
			ldi      0
			sat      temp1
			jmp      code_0af9
code_0b74:
			ldi      0
			sat      temp1
			jmp      code_0af9
code_0b7b:
			pushi    0
			callb    HandsOff,  0
			pushi    0
			callb    GetMaxHealth,  0
			push    
			ldi      14
			sagi     egoStats
			pushi    0
			callb    GetMaxStamina,  0
			push    
			ldi      15
			sagi     egoStats
			pushi    0
			callb    GetMaxMana,  0
			push    
			ldi      16
			sagi     egoStats
			pushi    0
			call     ResetLastViewedStats,  0
			pushi    #dispose
			pushi    0
			lofsa    poolBar
			send     4
			pushi    #dispose
			pushi    0
			pushi    2
			pushi    204
			pushi    0
			callk    ScriptID,  4
			send     4
			pushi    #dispose
			pushi    0
			lofsa    statDial
			send     4
			pushi    #dispose
			pushi    0
			lag      addToPics
			send     4
			pushi    #drawPic
			pushi    1
			pushi    401
			pushi    248
			pushi    1
			lst      temp2
			lag      curRoom
			send     12
			ret     
		)
	)
)
