;;; Sierra Script 1.0 - (do not remove this comment)
(script# STREET)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sleep)
(use Motion)
(use Game)
(use System)

(public
	Street 0
)

(local
	timesPickedLock
	timesClimbedWall
)
(instance Street of Locale
	(properties)
	
	(method (init)
		(if
			(and
				(not isNightTime)
				(or (!= (cSound number?) 93) (== (cSound state?) 0))
			)
			(cSound priority: 0 number: 93 loop: -1 play:)
		)
		(super init: &rest)
	)
	
	(method (handleEvent event &tmp [temp0 3] temp3 temp4 temp5)
		(cond 
			((super handleEvent: event))
			((!= (event type?) evSAID))
			(
				(or
					(Said 'nap')
					(Said 'go[<to]/nap')
					(Said 'get,get/nap')
				)
				(cond 
					((and (< 700 currentTime) (< currentTime 2550)) (HighPrint 811 0))
					((!= (ego onControl: origin) cBLACK) (HighPrint 811 1))
					((== curRoomNum 334) (SleepUntil 5 0))
					(else (ego setScript: egoSleepsInStreet))
				)
			)
			((Said 'look/door') (HighPrint 811 2))
			((Said '/window') (HighPrint 811 3))
			((Said 'open/window') (HighPrint 811 4))
			((Said 'unlock,lockpick/door,hasp')
				(= temp5 (ego onControl: origin))
				(cond 
					((not isNightTime) (HighPrint 811 5))
					((not [egoStats PICK]) (HighPrint 811 6))
					((not (CanPickLocks)) (HighPrint 811 7))
					((== temp5 cYELLOW) (curRoom notify: 1))
					(
					(or (== temp5 cLRED) (== temp5 cLGREEN) (== temp5 cLMAGENTA))
						(if (<= (Random 3 10) (++ timesPickedLock))
							(EgoDead 811 8
								#title { Nobody said this job was easy._}
								#icon vEgoDefeated 1 0
							)
						else
							(TrySkill PICK 0 0)
							(HighPrint 811 9)
						)
					)
					(else (HighPrint 811 10))
				)
			)
			((Said 'climb')
				(cond 
					((not [egoStats CLIMB]) (HighPrint 811 11))
					((and (not isNightTime) (!= curRoomNum 333)) (HighPrint 811 12))
					((<= (Random 3 10) (++ timesClimbedWall)) (HighPrint 811 13) (= timesClimbedWall 10))
					((TrySkill CLIMB tryClimbIntoTown 0)
						(switch curRoomNum
							(300
								(= temp3 (if (> (ego x?) 130) 65 else 73))
							)
							(310 (= temp3 73))
							(320 (= temp3 65))
							(333 (= temp3 53))
							(334 (= temp3 53))
							(else 
								(HighPrint 811 14)
								(= temp3 0)
							)
						)
						(if temp3 (HighPrint 811 15) (curRoom newRoom: temp3))
					)
					(else (HighPrint 811 16))
				)
			)
			((Said 'look>')
				(cond 
					((or (Said '<down') (Said '/ground')) (HighPrint 811 17))
					((or (Said '/sky') (Said '<up'))
						(if isNightTime
							(HighPrint 811 18)
						else
							(HighPrint 811 19)
						)
					)
					((Said '/wall') (HighPrint 811 20))
					((Said '/roof') (HighPrint 811 21))
					((Said '/hill') (HighPrint 811 22))
				)
			)
		)
	)
)

(instance egoSleepsInStreet of Script
	(properties)
	
	(method (changeState newState &tmp theCurRoomNum)
		(switch (= state newState)
			(0
				(HandsOff)
				(HighPrint 811 23)
				(ego view: vEgoTired setLoop: 3 cel: 0 setCycle: EndLoop self)
			)
			(1
				(SleepUntil 5 0)
				(= seconds 5)
			)
			(2
				(= theCurRoomNum curRoomNum)
				(= curRoomNum 999)
				(curRoom newRoom: theCurRoomNum)
			)
		)
	)
)
