;;; Sierra Script 1.0 - (do not remove this comment)
(script# 102)
(include system.sh) (include sci2.sh) (include game.sh)
(use Main)
(use Sound)
(use Motion)
(use Actor)
(use System)

(public
	AnimateThrowingRock 0
)

(local
	local0
	local1
	local2
	local3
	local4
	gEgoObjSignal
	gEgoObjPriority
	gEgoObjIllegalBits
	newAct
	newSound
)
(procedure (AnimateThrowingRock target &tmp temp0 temp1 newAct_2)
	(return
		(if (not (ego has: iRock))
			(HighPrint 102 0)
			;You do not have any rocks.
			(DisposeScript 102)
			(return FALSE)
		else
			(ego use: iRock 1)
			(Load RES_SOUND (GetSongNumber 58))
			(if target
				(FaceObject ego target)
				(= local3 (+ (target x?) (target targDeltaX?)))
				(= local4 (+ (target y?) (target targDeltaY?)))
				(= temp0 (- local3 (ego x?)))
				(= temp1 (- local4 (- (ego y?) 34)))
				(while
					(and
						(< westEdge local3)
						(< local3 eastEdge)
						(< 0 local4)
						(< local4 southEdge)
					)
					(= local3 (+ local3 temp0))
					(= local4 (+ local4 temp1))
				)
				(if
					(not
						(TrySkill THROW 0 (- 50 (/ (ego distanceTo: target) 5)))
					)
					(if (< local4 0)
						(= local4 (+ local4 (Random 30 100)))
					else
						(= local4 (- local4 (Random 30 100)))
					)
				)
			)
			(if (not target)
				;CI: why call SkillUsed directly, instead of TrySkill
				(SkillUsed THROW (/ [egoStats AGIL] tryStatThrowing))
				(= local3 (if (& (ego loop?) $0001) -10 else 330))
				(= local4 (Random 20 80))
			)
			(= local0 target)
			((= newAct_2 (Actor new:))
				view: vEgoThrowing
				setLoop: 4
				setCel: 0
				illegalBits: 0
				ignoreActors:
				ignoreHorizon:
				z: 20
				posn: (- (ego x?) 10) (- (ego y?) 12)
				setStep: 20 8
				init:
				hide:
				setPri: 15
				setScript: rockScript 0 target
			)
			(return TRUE)
		)
	)
)

(instance rockScript of Script
	(properties)
	
	(method (doit &tmp temp0)
		(asm
			pushi    1
			lsl      local0
			callk    IsObject,  2
			bnt      code_020e
			pushi    #x
			pushi    0
			lal      local0
			send     4
			push    
			pushi    #targDeltaX
			pushi    0
			lal      local0
			send     4
			add     
			sal      local3
			pushi    #y
			pushi    0
			lal      local0
			send     4
			push    
			pushi    #targDeltaY
			pushi    0
			lal      local0
			send     4
			add     
			sal      local4
code_020e:
			pushi    #x
			pushi    0
			pToa     client
			send     4
			push    
			lal      local3
			sub     
			sal      local1
			pushi    #y
			pushi    0
			pToa     client
			send     4
			push    
			lal      local4
			sub     
			sal      local2
			pTos     state
			ldi      1
			eq?     
			bnt      code_0296
			pushi    65521
			lal      local1
			lt?     
			bnt      code_024b
			pprev   
			ldi      15
			lt?     
			bnt      code_024b
			pushi    65521
			lal      local2
			lt?     
			bnt      code_024b
			pprev   
			ldi      15
			lt?     
code_024b:
			sat      temp0
			bt       code_0285
			pushi    #mover
			pushi    0
			pToa     client
			send     4
			not     
			bt       code_0285
			pushi    0
			pushi    #x
			pushi    0
			pToa     client
			send     4
			lt?     
			bnt      code_026c
			pprev   
			ldi      319
			lt?     
code_026c:
			not     
			bt       code_0285
			pushi    0
			pushi    #y
			pushi    0
			pToa     client
			send     4
			lt?     
			bnt      code_0281
			pprev   
			ldi      189
			lt?     
code_0281:
			not     
			bnt      code_0296
code_0285:
			pToa     register
			bnt      code_028c
			lat      temp0
code_028c:
			sal      gEgoObjSignal
			pushi    #cue
			pushi    0
			self     4
			jmp      code_029c
code_0296:
			pushi    #doit
			pushi    0
			super    Script,  4
code_029c:
			ret     
		)
	)
	
	(method (dispose)
		(newSound dispose:)
		(HandsOn)
		(if (and gEgoObjSignal (IsObject register))
			(register getHurt: TRUE)
		)
		(super dispose:)
		(DisposeScript 102)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(= gEgoObjPriority (ego signal?))
				(= gEgoObjIllegalBits (ego priority?))
				(= newAct (ego illegalBits?))
				(HandsOff)
				(ego
					view: vEgoThrowing
					cycleSpeed: 1
					setLoop: (if (& (ego loop?) $0001) 2 else 3)
					cel: 0
					setCycle: CycleTo 3 1 self
				)
				((= newSound (Sound new:))
					number: (GetSongNumber 58)
					priority: 15
					init:
				)
			)
			(1
				(ego setCycle: EndLoop)
				(client
					x: (if (== (ego loop?) 2)
						(- (ego x?) 10)
					else
						(+ (ego x?) 10)
					)
					show:
					setCycle: Forward
					setMotion: MoveTo local3 local4
				)
			)
			(2
				(client hide:)
				(if gEgoObjSignal
					(newSound play: self)
				else
					(= cycles 1)
				)
			)
			(3
				(StopEgo)
				(ego
					priority: gEgoObjIllegalBits
					illegalBits: newAct
					signal: gEgoObjPriority
				)
				(client dispose:)
			)
		)
	)
)
