;;; Sierra Script 1.0 - (do not remove this comment)
(include system.sh)

(define MAZEBUG 238)
(define CHARSAVE 601)

; General Game Defines
(define NUMSTATS 25)

; Picture defines
(define pBlueSkyForCarpet 750)

; Priority States
(define LowPri 4) ;pRED
(define HighPri 7)	;pLGREY

; Regions
(define ENCOUNTER 210)
(define ARENA 211)
(define TOWN 801)
(define FOREST 804)
(define GHOSTS 805)
(define CEMETERY 806)
(define CASTLE 807)
(define STREET 811)


; Character Classes
(enum
	FIGHTER
	MAGE
	THIEF
)

; Ego Moving Modes
(enum -1
	MOVE_NOCHANGE
	MOVE_WALK
	MOVE_RUN
	MOVE_SNEAK
)

; Skills
(enum
	STR			;0
	INT			;1
	AGIL		;2
	VIT			;3
	LUCK		;4
	WEAPON		;5
	PARRY		;6
	DODGE		;7
	STEALTH		;8
	PICK		;9
	THROW		;10
	CLIMB		;11
	MAGIC		;12
	EXPER		;13
	HEALTH		;14
	STAMINA		;15
	MANA		;16
; Magic Spells
	OPEN		;17
	DETMAGIC	;18
	TRIGGER		;19
	DAZZLE		;20
	ZAP			;21
	CALM		;22
	FLAMEDART	;23
	FETCH		;24
)

; ///////////////////////////////////////////////////////
; Inventory
; ///////////////////////////////////////////////////////
(enum 1
	iSilver			;1
	iGold			;2
	iRations		;3
	iMandrake		;4
	iBrassKey		;5
	iSword			;6
	iDagger			;7
	iLeather		;8
	iShield			;9
	iPaper			;10
	iFruit			;11
	iVegetables		;12
	iMagicGem		;13
	iVase			;14
	iCandelabra		;15
	iMusicBox		;16
	iCandlesticks	;17
	iPearls			;18
	invRing			;19
	iSeed			;20
	iRock			;21
	iFlowers		;22
	iLockPick		;23
	iThiefKit		;24
	iThiefLicense	;25
	iFlask			;26
	iGreenFur		;27
	iFairyDust		;28
	iFlyingWater	;29
	iMushroom		;30
	iCheetaurClaw	;31
	iTrollBeard		;32
	iChainmail		;33
	iHealingPotion	;34
	iManaPotion		;35
	iStaminaPotion	;36
	iHeroPotion 	;37		;Called "aa" in-game; according to the inventory script, it was intended to be a Potion of Heroism.
	iDisenchant 	;38
	iGhostOil 		;39
	iMagicMirror 	;40
	iAcorn 			;41
)

; ///////////////////////////////////////////////////////
; Time Zones
; ///////////////////////////////////////////////////////
(enum
	TIME_DAWN
	TIME_MIDMORNING
	TIME_MIDDAY
	TIME_MIDAFTERNOON
	TIME_SUNSET
	TIME_NIGHT
	TIME_MIDNIGHT
	TIME_NOTYETDAWN
)

;TrySkill and SkillUsed amounts
;Skill Used amounts
(define tryStatThrowing 10) ;full define should be (/ [egoStats AGIL] 10) but SCICompanion doesn't support those types of defines
(define tryStatWeaponMaster 50)
(define tryStatKoboldDazzle 5)
(define tryStatStableStr 25)
(define tryStatStableVit 40)
(define tryStatRandomEncounter 12) ;full define should be (/ [monsterHP (GetMonsterIndex monsterInRoom)] 12) but SCICompanion doesn't support those types of defines

;TrySkill thresholds
(define tryPickSecretEntrance 85)
(define tryForceSecretEntrance 40) ;strength
(define tryBreakDownBrigandGate 60) ;strength
(define tryClimbBrigandGate 65)
(define tryClimbIntoTown 35)
(define tryFetchKoboldKey 35)
(define tryForceOpenKoboldChest 40) ;strength
(define tryPickKoboldChest 70)
(define tryCastOpenKoboldChest 50) ;open spell
(define trySneak 5)
(define trySneakKobold 35)
(define tryPickNose 40)
(define tryCastOpenFox 25) ;open spell
(define tryClimbSpittingSpirea 35)
(define tryClimbWaterfall 30)
(define tryCastOpenHenry 45) ;magic, specifically.
(define tryThrowHenry 25)
(define tryFaeryDance 25) ;agility
(define tryThrowNest 25)
(define tryPickLOL 30)
(define tryPickSheriff 50)
(define tryWalkTreeLimb 30) ;agility (the tree outside the healer's)
(define tryPickTavern 10)

;Random Encounter Entrances
(define reNORTH 1)
(define reEAST	2)
(define reSOUTH 4)
(define reWEST	8)

;note, the other creatures have their maxHP in a array in RandomEncounters.sc
(define MAX_HP_OGRE 112)
(define MAX_HP_BRUTUS 100)
(define MAX_HP_KOBOLD 67)

; Nest Condition
(enum
	nestInTree
	nestOnGround
	nestBurnt
)

; Bar Drinks
(enum
	drinkNothing
	drinkAle
	drinkSweat
	drinkBreath
)

; Baba Yaga states
(enum
	babaNAME
	babaBRAVE
	babaFETCH
	babaBRING
	babaFINALE
)

; Baba Yaga's Hut states
(enum
	hutINITIAL
	hutMETSKULL
	hutNODEAL
	hutDEALMADE
	hutGAVEGEM
)

; Inn Meal States
(enum
	mealNOTHING
	mealORDERED
	mealATTABLE
	mealFINISHED
)

; Mages Maze
(define ChaseRange 30)
	; Directions
(enum
	mazeN
	mazeNE
	mazeE
	mazeSE
	mazeS
	mazeSW
	mazeW
	mazeNW
)
; Bug Sizes
(enum
	smallBug
	mediumBug
	largeBug
)
; doCommands
(enum
	mmazeNOTHING
	mmazeCHOOSE
	mmazeFETCH
	mmazeOPEN
	mmazeTRIGGER
	mmazeFLAME
)

; Kobold States
(enum
	koboldASLEEP
	koboldAWAKE
	koboldSTATE2
	koboldSTATE3
	koboldDEAD
)

; Event Flags
; flags are assigned for every room after ego leaves it.
; if these aren't set, then ego has never been in the room before.
(enum
	VISITED_ERANASPEACE 		;0
	VISITED_FOREST_11 			;1
	VISITED_FOREST_12 			;2
	VISITED_OGRE_ROOM 			;3
	VISITED_BEAR_CAVE 			;4
	VISITED_KOBOLD_CAVE 		;5
	VISITED_SPITTING_SPIREA 	;6
	VISITED_FOREST_17 			;7
	VISITED_FOREST_18 			;8
	VISITED_FOREST_19 			;9
	VISITED_ROOM_20 			;10 ;unused (Room 20 does not exist)
	VISITED_BABAYAGA_INTERIOR 	;11
	VISITED_BABAYAGA_EXTERIOR 	;12
	VISITED_FOREST_23 			;13
	VISITED_FOREST_24 			;14
	VISITED_FOREST_25 			;15
	VISITED_FOREST_26 			;16
	VISITED_FOREST_27 			;17
	VISITED_ERASMUS_OUTLOOK 	;18
	VISITED_ERASMUS_OUTSIDE 	;19
	VISITED_ERASMUS_INSIDE 		;20
	VISITED_ERASMUS_TOWER 		;21
	VISITED_WIZARDS_GAME 		;22 ;unused (Room 32 is the Wizard's Game)
	VISITED_FOREST_33 			;23
	VISITED_FOREST_34 			;24
	VISITED_FOREST_35 			;25
	VISITED_FOREST_36 			;26
	VISITED_CASTLE_GATE 		;27
	VISITED_CASTLE_BARRACKS 	;28
	VISITED_CASTLE_COURTYARD 	;29 ;unused
	VISITED_CASTLE_STABLES 		;30 ;unused
	VISITED_CASTLE_GUARDS 		;31
	VISITED_FOREST_42 			;32
	VISITED_FOREST_43 			;33
	VISITED_FOREST_44 			;34
	VISITED_GOBLIN_AMBUSH 		;35
	VISITED_ROOM_46 			;36 ;unused (deleted Goblin Cave scene)
	VISITED_ROOM_47 			;37 ;unused (deleted Goblin Cave scene)
	VISITED_ROOM_48 			;38 ;unused (deleted Goblin Cave scene)
	VISITED_ROOM_49 			;39 ;unused (deleted Goblin Cave scene)
	VISITED_ROOM_50 			;40 ;unused (deleted Goblin Cave scene)
	VISITED_FOREST_51 			;41
	VISITED_FOREST_52 			;42
	VISITED_FARM 				;43
	VISITED_HEALERHUT_OUTSIDE 	;44
	VISITED_HEALERHUT_INSIDE 	;45
	VISITED_FOREST_56 			;46
	VISITED_FOREST_57 			;47
	VISITED_FROST_CAVE 			;48
	VISITED_ROOM_59 			;49 ;unused (Room 59 does not exist)
	VISITED_MEEPS 				;50
	VISITED_FOREST_61 			;51
	VISITED_FOREST_62 			;52
	VISITED_FOREST_63 			;53
	VISITED_GRAVEYARD_DAYTIME 	;54
	VISITED_TOWNOVERLOOK 		;55
	VISITED_PATH_66 			;56
	VISITED_PATH_67 			;57
	VISITED_PATH_68 			;58
	VISITED_FOREST_69 			;59
	VISITED_FAERYRING 			;60 ;unused
	VISITED_FOREST_71 			;61
	VISITED_FOREST_72 			;62
	VISITED_TARGETRANGE 		;63 ;unused
	VISITED_FOREST_74 			;64
	VISITED_FOREST_75 			;65
	VISITED_DRYAD 				;66
	VISITED_STAG_77 			;67
	VISITED_STAG_78 			;68
	VISITED_FOREST_79 			;69
	VISITED_FOREST_80 			;70
	VISITED_FOREST_81 			;71 ;log crossroads
	VISITED_FLYINGFALLS 		;72
	VISITED_HENRYINSIDE 		;73
	VISITED_ANTWERP 			;74
	VISITED_FOREST_85 			;75
	VISITED_FOREST_86 			;76
	VISITED_LAKE 				;77
	VISITED_TROLLCAVE 			;78
	VISITED_TROLLCAVE2 			;79
	VISITED_ROOM_90 			;80 ;unused
	VISITED_BRIGAND_AMBUSH 		;81
	VISITED_FOREST_92 			;82
	VISITED_BRIGAND_GATE 		;83
	VISITED_BRIGAND_COURTYARD 	;84 ;wrong description... means something else.
	VISITED_BRIGAND_DININGHALL 	;85 ;unused
	VISITED_BRIGAND_JESTER 		;86
	VISITED_BRIGAND_LEADER 		;87
	VISITED_TOWNOUTLOOK 		;88
	VISITED_INN 				;89
	VISITED_OUTSIDE_MAGICSHOP 	;90
	VISITED_ADVENTURER_GUILD 	;91
	VISITED_LOL_HOUSE 			;92
	VISITED_MAGICSHOP_INSIDE 	;93
	VISITED_VEGGIE_STAND 		;94
	VISITED_SHERIFF_HOUSE 		;95
	VISITED_STORE 				;96
	VISITED_TAVERN_OUTSIDE 		;97
	VISITED_TAVERN_INSIDE 		;98
	VISITED_THIEVES_GUILD 		;99
	VISITED_ALLEY_DAY 			;100
	VISITED_ALLEY_NIGHT 		;101
)

; 102 through 109 are not defined	
(enum 110
	HERO_NO_STAMINA 			;110
	SHEMA_MAKING_ORDER 			;111
	SHEMA_BRINGS_ORDER 			;112
	OBTAINED_BAR_NOTE 			;113
	VISITED_GRAVEYARD_NIGHTTIME ;114	;NOTE: this VISITED flag is outside of the regular visited flags.
	ABDULLA_IS_AT_INN 			;115
	MET_ABDULLA 				;116
	TAVERN_THROWN_OUT 			;117
	TAVERN_DRUNK 				;118
	MET_SHOPKEEPER 				;119
	PURCHASED_FROM_DRYGOODS 	;120
	UNUSED_121 		;-----------event 121 is unused
	RENTED_ROOMATINN 			;122
	LEARNED_THIEF_PASSWORD 		;123
	HERO_HUNGRY 				;124
	HERO_STARVING 				;125
	ALLEY_ROBBED 				;126
	SIGNED_LOGBOOK 				;127
	SLEPT_AT_INN 				;128
	SAVE_ENABLED 				;129	; game saving is disabled in certain rooms, like during battles.
	SEARCHED_LOL_COUCH 			;130
	SEARCHED_LOL_BASKET 		;131
	SEARCHED_LOL_PURSE 			;132
	STOLE_CANDLESTICKS 			;133
	SEARCHED_LOL_DESK 			;134
	UNCOVERED_BIRDCAGE 			;135
	OBTAINED_SPIREA_SEED 		;136
	SMASHED_FLOWER1 			;137
	SMASHED_FLOWER2 			;138
	SMASHED_FLOWER3 			;139
	PICKED_ERANA_FLOWERS 		;140
	LEARNED_CALM 				;141
	ERASMUS_WARPOUT 			;142
	WRONG_ANSWER 				;143
	SEARCHED_SHERIFF_DRAWER 	;144
	SEARCHED_SHERIFF_SAFE 		;145
	UNUSED_146		;----------- event 146 is unused
	OBTAINED_KOBOLD_KEY 		;147
	HAVE_KOBOLD_MUSHROOMS 		;148	; replaced flag 174 in 1.200
	BEAR_CAVE_FIRST_ENTRY 		;149	; used to trigger the inital entrance message
	DEFEATED_KOBOLD 			;150
	KOBOLD_CHEST_UNLOCKED 		;151
	UNUSED_152		;----------- event 152 is unused
	KOBOLD_AWAKE 				;153
	ERASMUS_ATTACKED 			;154
	SAW_RED_SIGN 				;155
	SAW_GREEN_SIGN 				;156
	UNUSED_157		;----------- event 157 is unused	
	MANTRAY_LEFT 				;158
	MANTRAY_RIGHT 				;159
	BEAR_FRIENDLY 				;160
	BEAR_GONE 					;161
	UNUSED_162		;----------- unused
	UNUSED_163		;----------- events 162-163 are unused
	GHOSTS_ATTACK 				;164
	OBTAINED_TOADSTOOLS 		;165
	FIGHTING_KOBOLD 			;166
	MET_BEAR 					;167
	PROTECTED_UNGUENT 			;168
	DEFEATED_BEAR 				;169
	SAVED_BARNARD 				;170
	MET_BONEHEAD 				;171
	BABAYAGA_HUT_OPEN 			;172
	BABAYAGA_FLY_AWAY 			;173
	KOBOLD_CASTING_REVERSAL 	;174	; originally used for checking if player has Kobold Toadstools
	KOBOLD_CHEST_SEARCHED 		;175
	ENTERED_FOX_ROAD_1 			;176
	ENTERED_FOX_ROAD_2 			;177)
	UNUSED_178		;----------- event 178 is unused
	STOLE_SHERIFF_VASE 			;179
	MOVED_SHERIFF_VASE 			;180
	STOLE_SHERIFF_CANDELABRA 	;181
	STOLE_OTTO_MUSIC_BOX 		;182
	UNCOVERED_SHERIFF_SAFE 		;183
	CRACKED_SHERIFF_SAFE 		;184
	UNUSED_185		;----------- event 185 is unused
	DANCED_FOR_FAIRIES 			;186
	DANCING_FOR_FAIRIES 		;187
	GOT_FAIRIES_ATTENTION 		;188
	GOT_KARL_ATTENTION 			;189
	CLIMBED_SPIREA_LEDGE 		;190
	EXITED_TOWN 				;191
	SPIREA_INACTIVE 			;192
	OTTO_BACK_TO_BED 			;193
	OPEN_MUSIC_BOX 				;194
	OTTO_CLOSES_MUSIC_BOX 		;195
	SHERIFF_AWAKENED 			;196
	MET_DRYAD 					;197
	DRYAD_AGREED_HELP 			;198
	EXITED_TOWN_2 				;199
	UNUSED_200		;----------- event 200 is unused
	DISPEL_LEARNED_RECIPE 		;201
	STAG_PRESENT 				;202
	STAG_HURT 					;203
	ANTWERP_SKY 				;204
	HERO_OVERENCUMBERED 		;205
	ANTWERP_SPLIT 				;206
	MET_FOX 					;207
	OBTAINED_GEM 				;208
	LOOKED_IN_PTERESA_NEST 		;209
	OBTAINED_RING 				;210
	FLAG_211 					; event 211 is tested outside Healer's house, but is never set
	PTERESA_LEFT_NEST 			;212
	WHACKED_BY_GIANT 			;213
	UNUSED_214		;----------- event 214 is unused
	OBTAINED_BARNARD_REWARD 	;215
	KOBOLD_CHEST_KNOWN 			;216
	STABLE_CLEAN 				;217
	DISPEL_GAVE_DUST 			;218
	DISPEL_GAVE_FUR 			;219
	DISPEL_GAVE_FLOWERS 		;220
	DISPEL_GAVE_ACORN 			;221
	DISPEL_GAVE_WATER 			;222
	DISPEL_HEALER_MAKING_POTION ;223
	OBTAINED_DISPEL_POTION 		;224
	MET_HEALER 					;225
	STOLE_HEALER_POTIONS 		;226	; banned from Healer's hut
	OBTAINED_GREEN_FUR 			;227
	LEARNED_DETECT 				;228
	MET_STABLEMAN 				;229
	RETURNED_RING 				;230
	UNUSED_231		;----------- event 231 is unused
	DEFEATED_FIRST_GOBLIN 		;232	; "Wow! You threw that dead Goblin a long way!"
	FLAG_233					;MONSTER_HIT?? unsure; related to combat
	UNUSED_234		;----------- event 234 is unused
	SPIED_THIEVES 				;235
	HENRY_LADDER_KNOWN 			;236
	DEFEATED_MINOTAUR 			;237	; He's not actually dead, just unconscious
	BRIGAND_GATE_OPEN 			;238
	FLAG_239 					;EVENT_FIGHTINGWEAPONMASTER?? Unsure
	HENRY_DEADLY_TP 			;240	; teleported dangerously away by henry.
	HENRY_SAFE_TP 				;241	; teleported away safely by Henry
	ASKED_TRIGGER_SCROLL 		;242
	FLAG_243 					; Event 243 is related to the Weapons Master
	BRIGANDS_BEHIND_LOG 		;244
	OBTAINED_BRUTUS_KEY 		;245
	LAKE_EASTER_EGG 			;246
	SAID_HIDEN_GOSEKE 			;247
	HERO_KILLED_IN_BATTLE 		;248
	DEFEATED_WEAPON_MASTER 		;249
	DEFEATED_FRED 				;250
	DEFEATED_FRED_89 			;251
	TROLL_DOOR_UNLOCKED 		;252
	TROLL_DOOR_OPEN 			;253
	HERO_SITTING 				;254
	ORDERED_DRINK 				;255
; Events 256-260 are related to Yorick's maze
	FLAG_256
	OPENING_LEADER_DOOR 		;257
	FLAG_258
	PULLED_CHAIN 				;259
	FLAG_260
	
	DEFEATED_BRUTUS 			;261
	LEARNED_TRIGGER 			;262
	FLAG_263					;263 (used in Yorrick's room)
	FLAG_264					;264 (used in brigandDoorFall
	FLAG_265					;265 (used in Yorrick's room) 
	ERASMUS_ASKED_MAZE_GAME 	;266
	JESTER_NO_MORE_TALKING 		;267
	BEFRIENDED_JESTER 			;268
	FLAG_269					; set in brigandHappyFace
	FLAG_270					; set in brigandFallSideways
	FLAG_271					;271 (tested in Yorrick's room)
	CLIMBED_HENRY_CLIFF			;272
	SAVED_ELSA 					;273
	FLAG_274					;274 used in hermitHits
	KNOCKED_HENRY_DOOR 			;275
	FLAG_276					;276 used in hermitHits
	FLAG_277					;277 used in healerGetNest
	CLIMBED_HEALER_TREE 		;278
	HAVE_FAIRY_MUSHROOMS 		;279
	FLAG_280					;280 (set in Kobold Flame Dart)
	FLAG_281					;281 (set in Kobold Flame Dart)
	KOBOLD_CHEST_EXPLODED 		;282
	FLAG_283					;283 (cleared in Kobold Flame Dart)
	UNUSED_284		;----------- 
	UNUSED_285		;----------- 
	UNUSED_286		;----------- 
	UNUSED_287		;----------- 
	UNUSED_288		;----------- 
	UNUSED_289		;----------- 
	UNUSED_290		;----------- 
	UNUSED_291		;----------- 
	UNUSED_292		;----------- 
	UNUSED_293		;----------- 
	UNUSED_294
	UNUSED_295
	UNUSED_296
	UNUSED_297
	UNUSED_298
	SLINK_WARNING 				;299
	SHAMEEN_SIGNALING 			;300
	SHEMA_ASKS_ORDER 			;301
	EATEN_AT_INN 				;302
	FLAG_303					;303 related to InnHeroTale (possibly never set?)
	STOP_FIGHTING_WEAPONMASTER 	;304
	MET_GREEN_MEEP 				;305
	UNUSED_306
	UNUSED_307
	UNUSED_308
	UNUSED_309
	UNUSED_310
	UNUSED_311
	TALKED_BEAR 				;312
	UNUSED_313
	UNUSED_314
	UNUSED_315
	UNUSED_316
	UNUSED_317
	UNUSED_318
	UNUSED_319
	UNUSED_320
	OFFERED_TRAINING 			;321
	FLAG_322
	FARMER_IS_EAST 				;323
	FLAG_324
	fBabaFrog 					;325	;original name
	BABAYAGA_CURSE 				;326
	ATE_FAIRY_MUSHROOMS 		;327
	fInMainGame 				;328	; This flag is set when we're in the game proper. Original name from QFG2's import script.
	HAVE_FLYING_WATER 			;329
	HAVE_LAKE_WATER 			;330
	DEFEATED_OGRE 				;331
	OPENED_OGRE_CHEST 			;332
	SEARCHED_OGRE_CHEST 		;333
	DISPEL_HEALER_KNOWS_RECIPE 	;334
	SEARCHED_FRED_TREASURE 		;335
	GAVE_GEM_BONEHEAD 			;336
	GIVE_UP_MAZE_GAME 			;337
	GAVE_HERMIT_RATION 			;338	; Can sleep at the Hermit's cave with this flag set
	UNUSED_339		;----------- 
	SHAVED_FRED 				;340
	OGRE_GONE 					;341	; Ogre disappears day after his death
	UNUSED_342		;----------- 
	UNUSED_343		;----------- 
	UNUSED_344		;----------- 
	HIGH_SPEED_HERO				;345 (unused in v1.200)
	UNUSED_346		;----------- 
	GENEROUS_TO_ABDULLA 		;347
	BRIGANDS_UNAWARE 			;348
	UNUSED_349		;----------- 
	UNUSED_350		;----------- 
	FLAG_351					;351 set in arenaMantrayFight after killing the mantaray
	HENRY_DOOR_OPEN 			;352
	ERASMUS_KNOWS_HERO_HAS_MAGIC ;353
	MET_GARGOYLE 				;354
	READ_BARNARD_BULLETIN 		;355
)

; ///////////////////////////////////////////////////////
; Puzzle Point Event Flags (142 flags allocated; 6 flags unused: 609, 692, 710, 712, 714, 716)
; ///////////////////////////////////////////////////////
(define POINTS_KILLBEAR 601)             ; -25 points
(define POINTS_KILLKOBOLD 602)           ; 10 points (Fighter or Magic User only)
(define POINTS_SMASHSPIREA 603)          ; -10 points
(define POINTS_KILLFOX 604)              ; -10 points
(define POINTS_GOTDRUNK 605)             ; -5 points
; events 606 to 644 are character specific points, listed at bottom.
(define POINTS_EATERANAFRUIT 645)        ; 2 points
(define POINTS_CALMBEAR 646)             ; 5 points
(define POINTS_FREEBEAR 647)             ; 25 points
(define POINTS_ENTERKOBOLDCAVE 648)      ; 2 points
(define POINTS_TAKEKOBOLDKEY 649)        ; 7 points
(define POINTS_TAKEKOBOLDMONEY 650)      ; 5 points
(define POINTS_GETSEED 651)              ; 8 points
(define POINTS_ENTERBABAYAGAHUT 652)     ; 2 points
(define POINTS_TURNBABAYAGAINTOFROG 653)     ; 50 points
(define POINTS_GIVEMANDRAKEROOT 654)     ; 3 points
(define POINTS_MAKEDEALWITHSKULL 655)        ; 2 points
(define POINTS_GIVEGEM 656)              ; 10 points
(define POINTS_HUTSIT 657)               ; 7 points
(define POINTS_ENTERERASMUSCASTLE 658)       ; 3 points
(define POINTS_TALKTOERASMUS 659)        ; 1 point
(define POINTS_ENTERCASTLECOURTYARD 660)         ; 1 point
(define POINTS_TALKTOWEAPONMASTER 661)       ; 1 point
(define POINTS_WORKINSTABLES 662)        ; 5 points
(define POINTS_MEETBARON 663)            ; 10 points
(define POINTS_TALKTOBARON 664)          ; 3 points
(define POINTS_TALKTOFARMER 665)         ; 1 points
(define POINTS_TALKTOFARMERABOUTLEADER 666)     ; 3 points
(define POINTS_GETGOLDRING 667)          ; 3 points
(define POINTS_TALKTOHEALER 668)         ; 2 points
(define POINTS_RETURNRING 669)           ; 10 points
(define POINTS_SELLMUSHROOM 670)         ; 1 point
(define POINTS_SELLCHEETAURCLAW 671)     ; 2 points
(define POINTS_SELLTROLLBEARD 672)       ; 2 points
(define POINTS_SELLFLOWERS 673)          ; 1 points
(define POINTS_GIVEFLYINGWATER 674)      ; 2 points
(define POINTS_GIVEMAGICACORN 675)       ; 5 points
(define POINTS_GIVEGREENFUR 676)         ; 2 points
(define POINTS_GIVEFAIRYDUST 677)        ; 2 points
(define POINTS_GETDISPELPOTION 678)      ; 7 points
(define POINTS_GETGLOWINGGEM 679)        ; 8 points
(define POINTS_TALKTOMEEP 680)           ; 1 point
(define POINTS_GETGREENFUR 681)          ; 5 points
(define POINTS_USEUNDEADUNGUENT 682)     ; 2 points
(define POINTS_GETMANDRAKEROOT 683)      ; 6 points
(define POINTS_LEAVETOWNFIRSTTIME 684)       ; 1 point
(define POINTS_RECEIVEBADADVICEFROMBRUNO 685)        ; 2 points
(define POINTS_FREEFOX 686)              ; 10 points
(define POINTS_TALKTOFAIRIES 687)            ; 1 point
(define POINTS_DANCEWITHFAIRIES 688)         ; 3 points
(define POINTS_GETFAIRYDUST 689)         ; 8 points
(define POINTS_PICKMUSHROOMS 690)        ; 3 points
(define POINTS_OVERHEARBRUNO 691)        ; 12 points
; no event 692
(define POINTS_AGREETOHELPDRYAD 693)     ; 1 point
(define POINTS_GIVESEED 694)             ; 7 points
(define POINTS_GETACORN 695)             ; 1 point
(define POINTS_EATACORN 696)             ; -5 points
(define POINTS_KNOCKONHERMITDOOR 697)        ; 1 point
(define POINTS_GETFLYINGWATER 698)       ; 3 points
(define POINTS_MEETHERMIT 699)           ; 5 points
(define POINTS_TALKTOHERMIT 700)         ; 2 points
(define POINTS_FINDSECRETENTRANCE 701)       ; 10 points
(define POINTS_GIVECAVEPASSWORD 702)         ; 5 points
(define POINTS_VISITLAKE 703)            ; 1 point
(define POINTS_ENTERSECRETENTRANCE 704)      ; 2 points
(define POINTS_ENTERBRIGANDFORTRESS 705)     ; 8 points
(define POINTS_ENTERBRIGANDDININGROOM 706)       ; 8 points
(define POINTS_ENTERBRIGANDJESTERROOM 707)       ; 8 points
(define POINTS_TALKTOJESTER 708)         ; 2 points
(define POINTS_TALKTOJESTERABOUTELSA 709)        ; 8 points
; no event 710
(define POINTS_ENTERBRIGANDLEADERROOM 711)       ; 12 points
; no event 712
(define POINTS_DISPELBRIGANDLEADER 713)          ; 35 points
; no event 714
(define POINTS_TAKEMAGICMIRROR 715)      ; 10 points
; no event 716
(define POINTS_BEGINGAME 717)            ; 1 point
(define POINTS_TALKTOSHERIFF 718)        ; 1 point
(define POINTS_TALKTOSHAMEEN 719)        ; 1 point
(define POINTS_TALKTOABDULA 720)         ; 5 points
(define POINTS_EATKATTAFOOD 721)         ; 1 point
(define POINTS_RENTROOM 722)             ; 1 point
(define POINTS_READLOGBOOK 723)          ; 4 points
(define POINTS_SIGNLOGBOOK 724)          ; 1 point
(define POINTS_TALKTOGUILDMASTER 725)        ; 1 point
(define POINTS_READNOTICEBOARD 726)      ; 6 points
(define POINTS_TALKTOZARA 727)           ; 1 point
(define POINTS_BUYAPPLES 728)            ; 3 points
(define POINTS_TALKTOCENTAURGIRL 729)        ; 1 point
(define POINTS_TALKTOSHOPKEEPER 730)         ; 1 point
(define POINTS_PICKUPNOTE 731)           ; 2 points
(define POINTS_TALKTOBEGGAR 732)         ; 1 point
(define POINTS_GIVEALMS 733)             ; 1 point
(define POINTS_WINGAME 734)              ; 25 points
(define POINTS_TALKTOGATEKEEPER 735)         ; 5 points
(define POINTS_GIVEABDULAFOOD 736)       ; 2 points
; FIGHTER ONLY POINTS
(define POINTS_FIGHTWEAPONMASTER 607)        ; 3 points (Fighter only)
(define POINTS_DEFEATWEAPONMASTER 608)       ; 10 points (Fighter only)
; no event 609
(define POINTS_BUYCHAINMAIL 610)         ; 3 points (Fighter only)
(define POINTS_KILLTROLL 611)            ; 4 points (Fighter only)
(define POINTS_KILLCHEETAUR 612)         ; 4 points (Fighter Only)
(define POINTS_KILLSAURUSREX 613)        ; 4 points (Fighter Only)
(define POINTS_KILLMINOTAUR 737)         ; 5 points (Fighter only)
(define POINTS_KILLMANTRAY 738)          ; 2 points (Fighter only)
(define POINTS_KILLOGRE 739)             ; 2 points (Fighter only)
(define POINTS_KILLBRIGAND 740)          ; 1 point (Fighter Only)
(define POINTS_KILLSAURUS 741)           ; 1 point (Figher only)
(define POINTS_KILLGOBLIN 742)           ; 1 point (Fighter Only)
; THIEF ONLY POINTS
(define POINTS_GETROBBED 606)            ; -10 points (Thief only)
(define POINTS_ENTERLOLHOUSE 623)        ; 5 points (Thief Only)
(define POINTS_SEARCHLOLDESK 624)        ; 1 point (Thief Only)
(define POINTS_SEARCHLOLCOUCH 625)       ; 1 point (Thief Only)
(define POINTS_SEARCHLOLPURSE 626)       ; 1 point (Thief Only)
(define POINTS_SEARCHLOLBASKET 627)      ; 1 point (Thief Only)
(define POINTS_TAKECANDLESTICKS 628)         ; 1 point (Thief Only)
(define POINTS_PETLOLCAT 629)            ; 3 points (Thief Only)
(define POINTS_ENTERSHERIFFHOUSE 630)        ; 5 points (Thief only)
(define POINTS_SEARCHSHERIFFDRAWER 631)      ; 1 point (Thief only)
(define POINTS_MOVEPAINTING 632)         ; 1 point (Thief only)
(define POINTS_CRACKSAFE 633)            ; 1 point (Thief only)
(define POINTS_TAKESAFEMONEY 634)       ; 1 point (Thier only)
(define POINTS_TAKEVASE 635)             ; 1 point (Thief only)
(define POINTS_TAKECANDELABRA 636)       ; 1 point (Thief only)
(define POINTS_TAKEMUSICBOX 637)         ; 1 point (Thief only]
(define POINTS_ENTERTHIEVESGUILD 638)        ; 5 points (Thief Only)
(define POINTS_BUYTHIEFLICENSE 639)      ; 3 points (Thief Only)
(define POINTS_BUYTHIEFTOOLKIT 640)      ; 3 points (Thief Only)
(define POINTS_FENCEGOODS 641)           ; 3 points (Thief only)
(define POINTS_SHOWTHIEFSIGN 642)        ; 3 points (Thief only)
(define POINTS_PLAYDAGNABIT 643)         ; 3 points (Thief Only)
(define POINTS_WINDAGNABITSMALL 644)         ; 5 points (Thief Only)
; MAGE ONLY POINTS
(define POINTS_LEARNCALM 614)            ; 4 points (Mage only)
(define POINTS_SLEEPERANA 615)           ; 5 points (Mage only)
(define POINTS_PLAYWIZARDGAME 616)       ; 5 points (Mage only)
(define POINTS_WINWIZARDGAME 617)        ; 12 points (Mage only)
(define POINTS_LEARNDETECTMAGIC 618)         ; 4 points (Mage only)
(define POINTS_LEARNTRIGGER 619)         ; 4 points (Mage only)
(define POINTS_LEARNFETCH 620)           ; 2 points (Mage only)
(define POINTS_LEARNOPEN 621)            ; 2 points (Mage only)
(define POINTS_LEARNFLAMEDART 622)       ; 2 points (Mage only)

; Monster Arenas
(define KOBOLD 15)
(define BEAR 420)
(define MINOTAUR 425)
(define SAURUS 430)
(define MANTRAY 435)
(define CHEETAUR 440)
(define GOBLIN 445)
(define TROLL 450)
(define OGRE 455)
(define SAURUSREX 460)
(define BRIGAND 465)

; Ego-Related View
(define vEgo 		000)
(define vEgoFalling 003)
(define vEgoStanding 004)
(define vEgoRunning	005)
(define vEgoSneaking 006)
(define vEgoRunFast 007)
(define vEgoSleep 010)
(define vEgoCatchSeed 016)
(define vEgoFrogTransform 019)
(define vEgoJailDeath	039)
(define vEgoWalkTree	055)
(define vEgoPickupMeep 062)
(define vEgoDrawWeapon 068)
(define vEgoDance 		071)
(define vEgoGetFaeryDust 072)
(define vEgoKilledByDryad 079)
(define vEgoTeleportHenry 081)
(define vEgoSittingHenry 083)
(define vEgoKillAntwerp 	085)
(define vEgoWaterReflection 087)
(define vEgoFlattenedByJesterDoor 096)
(define vEgoFlyingCarpet	101)
(define vEgoHoldingMirror	122)
(define vEgoWithMedal 	139)
(define vEgoWorking		140)
(define vEgoLarge		148)
(define vEgoSwing	195)
(define vEgoJesterRoom 296)
(define vEgoJumping 400)
(define vEgoFightWithSword 501)
(define vEgoBeginFight 502)
(define vEgoDefeated 503)
(define vEgoInsideBar 	504)
(define vEgoCharSelect 	505)
(define vEgoDeadBrigands 	507)
(define vEgoHeroPose 	508)
(define vEgoClimbLadder	509)
(define vEgoThrowing 510)
(define vEgoFightDagger 511)
(define vEgoFightDaggerNoCape 512)
(define vEgoDaggerDefeated 513)
(define vEgoSwordDefeated 514)
(define vEgoTired 515)
(define vEgoDefeatedMagic 516)
(define vEgoClimbing 517)
(define vEgoSwordSpirea 518)
(define vEgoDanceBow 	519)
(define vEgoMagicFetch 	520)
(define vEgoMagicDetect 521)
(define vEgoMagicFlameDart 522)
(define vEgoFall 523)
(define vEgoThrowDagger 524)
(define vEgoBigGrin 	525)

(define vEgoFightArmDagger 	535)
(define vEgoFall2 	536)
(define vEgoShock 	537)
(define vEgoFallDown 538)
(define vEgoFightArmSword 540)
(define vEgoFightHead 541)
(define vEgoFightArmEmpty 542)
(define vEgoBreathHeavy 550)









(define vEranasPeace 010)
(define vKoboldCave 015)
(define vSpittingSpirea 016)
(define vFrogTransform 019)
(define vBabaYaga1	020)
(define vBabaYaga2	021)
(define vBabaHut	022)
(define vBonehead	023)
(define vWizardWarning 028)
(define vWizardDoor	029)
(define vWizardLobby	030)
(define vWizardTable	031)
(define vWizGameUI		032)
(define vWizGameMonster	033)
(define vCastleGate 	037)
(define vBarracksMan 	038)
(define vCastleGuards 	039)
(define vStables 		040)
(define vCastleGuards2 	041)

(define vFarmerRaking	053)
(define vFarmerTalking 	054)
(define vHealerOutside 	055)
(define vHealerInside 	056)
(define vHealer 		057)
(define vFrostGiant 	059)
(define vMeeps 			060)
(define vGreenMeep		061)
(define vMandrake 		063)
(define vGhosts 		064)
(define vBruno 		 	065)
(define vFox 			067)
(define vFaery 			070)
(define vBrutus 		073)
(define vThrowingRange 	074)
(define vDryad 			076)
(define vDryadRoom 		077)
(define vStag 			078)
(define vStagJump 		080)
(define vHenryDoor 		081)
(define vHenryOutside 	082)
(define vHenryInside 	083)
(define vSecretEntranceRock 084)
(define vWater 			087)
(define vTrollCave 		088)
(define vArrows 		090)
(define vArchers 		091)
(define vBrigandEntrance 	093)
(define vBrigandCourtyard 094)
(define vBrigandDiningHall 095)
(define vJesterRoom 	096)
(define vBrigandLeader 097)
(define vGameSelect 	100)
(define vEndGameCast	139)

(define vBaronett 		141)
(define vTownGate		165)
(define vKoboldSitting	175)
(define vKoboldFighting	176)
(define vKoboldMagic	177)
(define vKoboldDead		178)
(define vKoboldReflect 179)
(define vHollowLog		181)
(define vBrigandLarry 	186)
(define vBrigandMoe 	187)
(define vBrigandCurly 	188)
(define vBrigandArcher 	194)
(define vBrigandDoor 196)
(define vFenrus 199)
(define vBushEyes 240)
(define vBrigandTrio 295)
(define vJesterTrapDoor 296)
(define vYorick 297)
(define vYorickLeave 298)
(define vEgoGrab 	298)
(define vTownOutlook 300)
(define vInn 	301)
(define vEgoEatingSleeping 301)
(define vInnCast 302)
(define vSheema 303)
(define vSheemaFood 304)
(define vTownMagicOutside 310)
(define vAdventurerGuild 311)
(define vWolfgang 312)
(define vLOLInside 313)
(define vMagicShop 314)
(define vZara 315)
(define vNoticeBoard 318)
(define vTownDryGoodsOutside 320)
(define vSheriffHouse 321)
(define vDryGoodsInside 322)
(define vCentaurGirl 325)
(define vTownBarOutside 330)
(define vBarInside 331)
(define vThiefGuildMaster 332)
(define vAlley 333)
(define vBartender 336)
(define vBartenderPouring 337)
(define vCrusher 338)
(define vDartGame 340)
(define vDartBoard 341)

;All Fighting Characters
(define vBear 			420)
(define vBearDefeated 	421)
(define vBearFight 		422)
(define vBearHumanFight 423)
(define vArenaDazzle 424)
(define vMinotaur 		425)
(define vMinotaurDefeated 426)
(define vMinotaurFight 	427)
(define vSaurus 		430)
(define vSaurusDefeated 431)
(define vSaurusFight 	432)
(define vMantray 		435)
(define vMantrayDefeated 436)
(define vMantrayFight 	437)
(define vCheetaur 		440)
(define vCheetaurDefeated 	441)
(define vCheetaurFight	442)
(define vGoblin 		445)
(define vGoblinDefeated 446)
(define vGoblinFight	447)
(define vGoblinBush 	448)
(define vTroll 			450)
(define vTrollDefeated	451)
(define vTrollFight 	452)
(define vOgre 			455)
(define vOgreDefeated 	456)
(define vOgreFight 		457)
(define vSaurusRex 		460)
(define vSaurusRexDefeated 	461)
(define vSaurusRexFight 	462)
(define vBrigand 		465)
(define vBrigandDefeated 466)
(define vBrigandFight 	467)
(define vBrigandLeaderFight 473)


(define vCharSelect 	506)
(define vTeleportPink 	530)
(define vTeleportGreen 	531)
(define vExplosion 	532)
(define vAntwerp 590)
(define vSheriffAsleep 601)
(define vOttoAsleep 602)
(define vOttoYoyo 606)
(define vMagicCat 635)
(define vEgoDeathByCat 636)
(define vCat 637)
(define vWeaponMaster 638)
(define vWeaponMasterTalk 639)
(define vEgoTalkWeaponMaster 639)
(define vBushes 700)
(define vSnow 702)
(define vBlack 777)
(define vDeathScenes 800)
(define vCharSheet 802)
(define vEgoCharSheet 802)
(define vFightUI 803)
(define vFightUiCGA 804)
(define vCreditsDragon 901)
(define vCredits 902)
(define vDragonHead 906)
(define vDragonFire 907)
(define vSierraPresents 908)
(define vSubtitle 913)
(define vQFGshadow 918)
(define vQFG 919)
(define vQFG2 920)
(define vTrialByFire 925)
(define vEndCreditsCarpet 925)